untyped
global function mmcr101Precache
global function OnWeaponPrimaryAttack_weapon_mmcr101
global function OnWeaponReload_weapon_mmcr101

void function mmcr101Precache(){
    #if CLIENT
    RegisterButtonPressedCallback(KEY_Z, buttonModeSwitch)
    PrecacheParticleSystem($"wpn_muzzleflash_pulse_FP")
    PrecacheParticleSystem($"P_mflash_pulse_LMG_FP")
    PrecacheParticleSystem($"wpn_shelleject_pistol_FP")
    PrecacheParticleSystem($"wpn_muzzleflash_smg_FP")
    PrecacheParticleSystem($"wpn_muzzleflash_lmg_FP")
    PrecacheParticleSystem($"wpn_shelleject_rifle_assault_FP")
    PrecacheParticleSystem($"P_wpn_mflash_dbltake_FP_burn")
    PrecacheParticleSystem($"xo_spark_med")
    thread mmcr101Main()
    #endif
}

#if CLIENT

vector s_ColIon = Vector(0.1, 0.4, 1.0)
vector s_ColKinetic = Vector(1.0, 0.25, 0.0)
vector s_lowAmmoIon = Vector(0.0, 0.0, 1.0)
vector s_lowAmmoKinetic = Vector(1.0, 0.0, 0.0)
bool isButtonLocked = false
bool hasIonButton = false
bool hasIon = false
bool hasKinetic = true
var crosshairRuiPlus = null
var crosshairRuiDot = null
var mode = null
var modeSwitch = null
var flyout = null

var customTopo = null

bool cns_reload_fx = false
bool cns_crosshair_rot = true
bool cns_ads_fade = true
bool cns_crosshair_ammo = true
float cns_crosshair_scale = 1.0
float cns_crosshair_scale_perm = 1.0

/*
x+    down
x-    up
y+    left
y-    right
z+    rotate clockwise
z-    rotate counterclockwise
*/
vector topoAnglesRot = < -0.085, 0.085, 45.0>
vector topoAnglesBase = < -0.085, 0.085, 0.0>

void function buttonLock(){
    isButtonLocked = true
    Wait(3.01)
    isButtonLocked = false
}

void function buttonModeSwitch(var button){
    if(isButtonLocked)
        return
    hasIonButton = !hasIonButton
}

void function mmcr101Main(){
    cns_crosshair_rot = (GetConVarInt("mmcr101_crosshair_rot") == 1) ? true : false
    cns_crosshair_scale = GetConVarFloat("mmcr101_crosshair_scale")
    cns_crosshair_scale_perm = cns_crosshair_scale

    customTopo = RuiTopology_CreateSphere(
    COCKPIT_RUI_OFFSET - <0.0, 0.5, 0.5>,
    AnglesToRight(cns_crosshair_rot ? topoAnglesRot : topoAnglesBase),
    AnglesToUp(cns_crosshair_rot ? topoAnglesRot : topoAnglesBase) * -1,
    COCKPIT_RUI_RADIUS * (1/cns_crosshair_scale),
    COCKPIT_RUI_WIDTH,
    COCKPIT_RUI_HEIGHT,
    COCKPIT_RUI_SUBDIV
    )
    /*
    ██████╗░██╗░░░██╗██╗      ██╗░██████╗      ██████╗░░█████╗░██╗███╗░░██╗
    ██╔══██╗██║░░░██║██║      ██║██╔════╝      ██╔══██╗██╔══██╗██║████╗░██║
    ██████╔╝██║░░░██║██║      ██║╚█████╗░      ██████╔╝███████║██║██╔██╗██║
    ██╔══██╗██║░░░██║██║      ██║░╚═══██╗      ██╔═══╝░██╔══██║██║██║╚████║
    ██║░░██║╚██████╔╝██║      ██║██████╔╝      ██║░░░░░██║░░██║██║██║░╚███║
    ╚═╝░░╚═╝░╚═════╝░╚═╝      ╚═╝╚═════╝░      ╚═╝░░░░░╚═╝░░╚═╝╚═╝╚═╝░░╚══╝
    */
    //clGlobal.topoCockpitHudPermanent
    var crosshairRuiPlus = RuiCreate($"ui/crosshair_plus.rpak", customTopo, RUI_DRAW_COCKPIT, 0)
    var crosshairRuiDot = RuiCreate($"ui/crosshair_wingman_n.rpak", customTopo, RUI_DRAW_COCKPIT, 1)
    //var sightsTestG2 = RuiCreate($"ui/g2a4_sights.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, 0)

    mode = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1)
	RuiSetInt(mode, "maxLines", 1)
	RuiSetInt(mode, "lineNum", 1)
	RuiSetFloat2(mode, "msgPos", <0.82, 0.35, 0.0>)
	RuiSetString(mode, "msgText", "Rounds:")
	RuiSetFloat(mode, "msgFontSize", 42.0)
	RuiSetFloat(mode, "msgAlpha", 0.0)
	RuiSetFloat(mode, "thicken", 0.0)
	RuiSetFloat3(mode, "msgColor", <1.0, 0.55, 0.0>)

    modeSwitch = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1)
	RuiSetInt(modeSwitch, "maxLines", 1)
	RuiSetInt(modeSwitch, "lineNum", 1)
	RuiSetFloat2(modeSwitch, "msgPos", <0.9, 0.35, 0.0>)
	RuiSetString(modeSwitch, "msgText", "kinetic")
	RuiSetFloat(modeSwitch, "msgFontSize", 42.0)
	RuiSetFloat(modeSwitch, "msgAlpha", 0.0)
	RuiSetFloat(modeSwitch, "thicken", 0.0)
	RuiSetFloat3(modeSwitch, "msgColor", <1.0, 1.0, 1.0>)

    for(;;){
        WaitFrame()
        entity player = GetLocalClientPlayer()
        if(!IsValid(player) || player == null || GetLocalClientPlayer() != GetLocalViewPlayer()){
            RuiSetFloat(crosshairRuiPlus, "adsFrac", 1.0)
            RuiSetFloat(crosshairRuiDot, "adsFrac", 1.0)
            continue
        }
        entity weapon = player.GetActiveWeapon()
        if(!IsValid(weapon) || weapon == null)
            continue
        cns_ads_fade = (GetConVarInt("mmcr101_ads_fade") == 1) ? true : false
        cns_reload_fx = (GetConVarInt("mmcr101_reload_fx") == 1) ? true : false
        cns_crosshair_ammo = (GetConVarInt("mmcr101_crosshair_ammo") == 1) ? true : false
        if(weapon.GetWeaponClassName() == "mp_weapon_rspn101_og"){
            //RuiSetFloat(sightsTestG2, "vis", (1 - player.GetZoomFrac()))

            SetConVarFloat("mmcr101_adsfrac_opa", (0.1 + 0.5*player.GetZoomFrac()))

            RuiSetFloat(crosshairRuiPlus, "adjustedSpread", ((1/cns_crosshair_scale_perm)*(0.03125*player.GetAttackSpreadAngle() + 0.03125)))

            RuiSetFloat(crosshairRuiDot, "adsFrac", player.GetZoomFrac())
            RuiSetFloat(crosshairRuiPlus, "adsFrac", player.GetZoomFrac())

            RuiSetBool(crosshairRuiPlus, "isReloading", weapon.IsReloading())
            RuiSetBool(crosshairRuiDot, "isReloading", weapon.IsReloading())

            RuiSetFloat3(crosshairRuiPlus, "teamColor", (!hasIonButton) ? s_ColKinetic : s_ColIon)
            RuiSetFloat3(crosshairRuiDot, "teamColor", (!hasIonButton) ? s_ColKinetic : s_ColIon)

            float ammoFrac = ((weapon.GetWeaponPrimaryClipCount().tofloat())/((weapon.HasMod("extended_ammo")) ? (30.0) : (24.0)))
            if(cns_crosshair_ammo && ammoFrac < 0.3){
                vector lowAmmoVector
                if(!hasIonButton){
                    lowAmmoVector = (((1 - (ammoFrac/0.3))*s_lowAmmoKinetic) + ((ammoFrac/0.3)*s_ColKinetic))
                    RuiSetFloat3(crosshairRuiPlus, "teamColor", lowAmmoVector)
                    RuiSetFloat3(crosshairRuiDot, "teamColor", lowAmmoVector)
                }
                else{
                    lowAmmoVector = (((1 - (ammoFrac/0.3))*s_lowAmmoIon) + ((ammoFrac/0.3)*s_ColIon))
                    RuiSetFloat3(crosshairRuiPlus, "teamColor", lowAmmoVector)
                    RuiSetFloat3(crosshairRuiDot, "teamColor", lowAmmoVector)
                }
            }

            RuiSetFloat(mode, "msgAlpha", (cns_ads_fade ? (0.9 - 0.45*player.GetZoomFrac()) : 0.9))
            RuiSetFloat(modeSwitch, "msgAlpha", (cns_ads_fade ? (0.9 - 0.45*player.GetZoomFrac()) : 0.9))

            RuiSetFloat3(modeSwitch, "msgColor", (hasIonButton ? s_ColIon : s_ColKinetic))
            RuiSetString(modeSwitch, "msgText", (hasIonButton ? "Ionised" : "Kinetic"))

            entity viewModel = player.GetViewModelEntity()

            //  ᖇ⋃ᓮ   ᓰ⟆   ᑭᗩᓰƝ

            if(hasIonButton && !hasIon){
                weapon.EmitWeaponSound_1p3p("weapon_smartpistol_slideback", "")
                weapon.EmitWeaponSound_1p3p("LSTAR_VentCooldown", "")
                weapon.EmitWeaponSound_1p3p("wpn_Thunderbolt_ADS_In_1P", "")
                weapon.PlayWeaponEffect($"P_wpn_mflash_arcball", $"", "muzzle_flash")

                flyout = CreateCockpitRui($"ui/weapon_flyout.rpak")
                RuiSetGameTime(flyout, "startTime", Time())
                RuiSetFloat(flyout, "duration", 3.0)
                RuiSetBool(flyout, "showWeaponXP", false)
                RuiSetFloat3(flyout, "color", s_ColIon)
                RuiSetString(flyout, "titleText", "Ionised Rounds")
                RuiSetString(flyout, "descriptionText", "Superheated plasma projectiles, additional damage against robotics.")
                RuiSetFloat(flyout, "underlineHeight", 4.0)
                RuiSetFloat(flyout, "underlineWidth", 4.0)
                RuiTrackFloat3(flyout, "pos", viewModel, RUI_TRACK_POINT_FOLLOW, viewModel.LookupAttachment("shell"))

                thread buttonLock()

                hasIon = true
                hasKinetic = false
            }
            if(!hasIonButton && !hasKinetic){
                weapon.EmitWeaponSound_1p3p("weapon_smartpistol_slideback", "")
                weapon.EmitWeaponSound_1p3p("wpn_Thunderbolt_ADS_Out_1P", "")
                weapon.EmitWeaponSound_1p3p("Weapon_Titan_Sniper_WindDown", "")

                flyout = CreateCockpitRui($"ui/weapon_flyout.rpak")
                RuiSetGameTime(flyout, "startTime", Time())
                RuiSetFloat(flyout, "duration", 3.0)
                RuiSetBool(flyout, "showWeaponXP", false)
                RuiSetFloat3(flyout, "color", s_ColKinetic)
                RuiSetString(flyout, "titleText", "Kinetic Rounds")
                RuiSetString(flyout, "descriptionText", "Base MCRN ammunition, additional damage against armor.")
                RuiSetFloat(flyout, "underlineHeight", 4.0)
                RuiSetFloat(flyout, "underlineWidth", 4.0)
                RuiTrackFloat3(flyout, "pos", viewModel, RUI_TRACK_POINT_FOLLOW, viewModel.LookupAttachment("shell"))

                thread buttonLock()

                hasIon = false
                hasKinetic = true
            }
        }
        else{
            RuiSetFloat(crosshairRuiPlus, "adsFrac", 1.0)
            RuiSetFloat(crosshairRuiDot, "adsFrac", 1.0)
            RuiSetFloat(mode, "msgAlpha", 0.0)
            RuiSetFloat(modeSwitch, "msgAlpha", 0.0)
            //RuiSetFloat(sightsTestG2, "vis", 0.0)
        }
    }
}

#endif

int function FireWeaponPlayerAndNPC(entity weapon, WeaponPrimaryAttackParams attackParams, bool playerFired){
	weapon.EmitWeaponNpcSound(LOUD_WEAPON_AI_SOUND_RADIUS_MP, 0.2)
	int damageType = weapon.GetWeaponDamageFlags()
	weapon.FireWeaponBullet(attackParams.pos, attackParams.dir, 1, damageType)
	return 1
}

var function OnWeaponPrimaryAttack_weapon_mmcr101(entity weapon, WeaponPrimaryAttackParams attackParams){
    #if CLIENT
    if(hasIonButton){
        weapon.PlayWeaponEffect($"wpn_muzzleflash_pulse_FP", $"", "muzzle_flash")
        if(weapon.GetWeaponPrimaryClipCount() == 1)
            weapon.PlayWeaponEffect($"P_mflash_pulse_LMG_FP", $"", "muzzle_flash")
        weapon.PlayWeaponEffect($"wpn_shelleject_pistol_FP", $"", "shell")
    }
    else{
        weapon.PlayWeaponEffect($"wpn_muzzleflash_smg_FP", $"", "muzzle_flash")
        if(weapon.GetWeaponPrimaryClipCount() == 1)
            weapon.PlayWeaponEffect($"wpn_muzzleflash_lmg_FP", $"", "muzzle_flash")
        weapon.PlayWeaponEffect($"wpn_shelleject_rifle_assault_FP", $"", "shell")
    }
    #endif
    return FireWeaponPlayerAndNPC(weapon, attackParams, true)
}

void function OnWeaponReload_weapon_mmcr101(entity weapon, int milestoneIndex){
    #if CLIENT
    if(cns_reload_fx){
        if(hasIonButton){
            weapon.PlayWeaponEffect($"P_wpn_mflash_dbltake_FP_burn", $"", "muzzle_flash")
            weapon.EmitWeaponSound_1p3p("LSTAR_VentCooldown", "")
        }
        else{
            weapon.PlayWeaponEffect($"xo_spark_med", $"", "muzzle_flash")
            weapon.EmitWeaponSound_1p3p("wpn_Thunderbolt_ADS_Out_1P", "")	    
        }
    }
    #endif
}